import math
import os
import numpy as np

# Transform binary VHXC file into text file

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS1_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")  #3D formatted data (output the bare 3D data - one column)
                files.write("EQ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS2_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")  
                files.write("LA+ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS3_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("LA- \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS4_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("LO+ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS5_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("LO- \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS6_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TA1+ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS7_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TA1- \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS8_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TA2+ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS9_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TA2- \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS10_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TO1+ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS11_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TO1- \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS12_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TO2+ \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

os.system("rm cut3d.files")
with open("cut3d.files","a") as files:
                files.write("outputo_DS13_VHXC \n")
                files.write("1 \n")
                files.write("5 \n")
                files.write("TO2- \n")
                files.write("0 \n")
os.system("cut3d < cut3d.files ")

# -----------------------------------------------------------------------
# Make centered finite difference of order 2 of Vhxc for each mode
# d2Vhxc/dR1dR2=(2*Vhxc(mode)-2*Vhxc(eq))/(h^2)
# ----------------------------------------------------------------------

mode = np.array(["EQ","LA+","LA-","LO+","LO-","TA1+","TA1-","TA2+","TA2-",
"TO1+","TO1-","TO2+","TO2-"])

# The phonon frequency are eigenvalue of the Dynamical eigenvalue problem.

omega = np.array([0.0,0.00480084,0.00480084,0.005785943,0.005785943,0.002453274,
0.002453274,0.002453274,0.002453274,0.005671174,0.005671174,0.005671174,0.005671174])

# ---------------------------------------------------------------------------
# Prepare the integration : de2/dR1dR2=int d2Vhxc/dR1dR2 psi*psi(unperturbed)
# ---------------------------------------------------------------------------

os.system("rm wfk.files")
with open("wfk.files","a") as files:
                files.write("outputo_DS1_WFK \n") #unperturbed wfk
                files.write("1 \n")
                files.write("0 \n")
                files.write("4 \n") # Gamma point
                files.write("6 \n") # Band nb 6
                files.write("0 \n") 
                files.write("0 \n") 
                files.write("2 \n") # real 3D data one column 
                files.write("wfk \n") 
                files.write("0 \n") 
os.system("cut3d < wfk.files ")

os.system("rm wfk.files")
with open("wfk.files","a") as files:
                files.write("outputo_DS1_WFK \n") #unperturbed wfk
                files.write("1 \n")
                files.write("0 \n")
                files.write("4 \n") # Gamma point
                files.write("7 \n") # Band nb 7
                files.write("0 \n") 
                files.write("0 \n") 
                files.write("2 \n") # real 3D data one column 
                files.write("wfk \n") 
                files.write("0 \n") 
os.system("cut3d < wfk.files ")

os.system("rm wfk.files")
with open("wfk.files","a") as files:
                files.write("outputo_DS1_WFK \n") #unperturbed wfk
                files.write("1 \n")
                files.write("0 \n")
                files.write("4 \n") # Gamma point
                files.write("8 \n") # Band nb 8
                files.write("0 \n") 
                files.write("0 \n") 
                files.write("2 \n") # real 3D data one column 
                files.write("wfk \n") 
                files.write("0 \n") 
os.system("cut3d < wfk.files ")

# ---------------------------------------
# Perform the integration
# ---------------------------------------

Sum_mode = 0.0
modetmp = 0.0

for i in range(len(mode)):
  # band nb 6
  fichier1 = str(mode[i])
  fichier2 = "wfk_k4_b6_s1"
  reader1 = open(fichier1,"r")
  reader2 = open(fichier2,"r")
  X1 = reader1.readlines()
  X2 = reader2.readlines()
  summa = 0.0
  for l in range(len(X2)):
    summa = summa + eval(X2[l].split()[0]) * eval(X2[l].split()[0])
  
  int = 0.0
  for ii in range(len(X1)):
    int = int + eval(X2[ii].split()[0]) * eval(X2[ii].split()[0]) * eval(X1[ii].split()[0])
  
  result1 = int/summa

  # band nb 7
  fichier1 = str(mode[i])
  fichier2 = "wfk_k4_b7_s1"
  reader1 = open(fichier1,"r")
  reader2 = open(fichier2,"r")
  X1 = reader1.readlines()
  X2 = reader2.readlines()
  summa = 0.0
  for l in range(len(X2)):
    summa = summa + eval(X2[l].split()[0]) * eval(X2[l].split()[0])

  int = 0.0
  for ii in range(len(X1)):
    int = int + eval(X2[ii].split()[0]) * eval(X2[ii].split()[0]) * eval(X1[ii].split()[0])
  
  result2 = int/summa

  # band nb 8
  fichier1 = str(mode[i])
  fichier2 = "wfk_k4_b8_s1"
  reader1 = open(fichier1,"r")
  reader2 = open(fichier2,"r")
  X1 = reader1.readlines()
  X2 = reader2.readlines()
  summa = 0.0
  for l in range(len(X2)):
    summa = summa + eval(X2[l].split()[0]) * eval(X2[l].split()[0])

  int = 0.0
  for ii in range(len(X1)):
    int = int + eval(X2[ii].split()[0]) * eval(X2[ii].split()[0]) * eval(X1[ii].split()[0])

  result3 = int/summa

  #Make the average of the three band
  average = (result1+result2+result3)/3  

  if mode[i][0:2] == "EQ":
    equili = average

  #--------------------------------
  # Mode contribution
  #--------------------------------
  print "<Psi0|VHXC|Psi0> ", average, " for mode", mode[i]
  
  if mode[i][2:3] == "+" or mode[i][3:4]== "+" or mode[i][0:2] == "EQ":
    modetmp = average

  else:    
    emodetmp = (average+modetmp-2*equili)/(0.01**2)
  
  Mcarbone = 21894.16693
  
  if mode[i][2:3] == "-" or mode[i][3:4]== "-":
    emode = (1/(4*omega[i]*Mcarbone))*emodetmp*(27.211383*1000) #(1/2 mode) 
    print ("Mode :"+mode[i]+"  "+str(emode))
   
  else:
    emode = 0.0
   
  Sum_mode += emode

# -----------------------------------------
# Compute the total NDDW ZPM
# -----------------------------------------

ZPM=Sum_mode 

print ("ZPM[meV]"+str(ZPM))	
