# Make all the calculation using Paul python scripts
import numpy as np
import math
import os

os.system("rm result_nddw.txt")
os.system("touch result_nddw.txt")

# Make the integration : de2/dR1dR2=int d2Vhxc/dR1dR2 psi*psi(unperturbed)

os.system("rm wfk.files")
with open("wfk.files","a") as files:
                files.write("ab2o_DS1_WFK \n") #unperturbed wfk
                files.write("1 \n")
                files.write("0 \n")
                files.write("1 \n") # Gamma point
                files.write("5 \n") #Band nb 2
                files.write("0 \n")
                files.write("0 \n")
                files.write("1 \n") #real and im 3D data one column 
                files.write("wfk \n")
                files.write("0 \n")
os.system("cut3d < wfk.files ")

os.system("rm wfk.files")
with open("wfk.files","a") as files:
                files.write("ab2o_DS1_WFK \n") #unperturbed wfk
                files.write("1 \n")
                files.write("0 \n")
                files.write("1 \n") # Gamma point
                files.write("6 \n") #Band nb 3
                files.write("0 \n")
                files.write("0 \n")
                files.write("1 \n") #real and im 3D data one column 
                files.write("wfk \n")
                files.write("0 \n")
os.system("cut3d < wfk.files ")

os.system("rm wfk.files")
with open("wfk.files","a") as files:
                files.write("ab2o_DS1_WFK \n") #unperturbed wfk
                files.write("1 \n")
                files.write("0 \n")
                files.write("1 \n") # Gamma point
                files.write("7 \n") #Band nb 4
                files.write("0 \n")
                files.write("0 \n")
                files.write("1 \n") #real and im 3D data one column 
                files.write("wfk \n")
                files.write("0 \n")
os.system("cut3d < wfk.files ")



ii= 2
order = 8
h = np.array([0.02, 0.01, 0.005, 0.0025, 0.00125, 0.000625, 0.0003125, 0.00015625])
D = np.zeros([len(h),len(h),4])

while ii < order*4:
  os.system("rm cut3d.files")
  with open("cut3d.files","a") as files:
                  files.write("ab2o_DS"+str(ii)+"_VHXC \n")
                  files.write("1 \n")
                  files.write("5 \n")  #3D formatted data (output the bare 3D data - one column)
                  files.write("V++ \n")
                  files.write("0 \n")
  os.system("cut3d < cut3d.files ")
  
  os.system("rm cut3d.files")
  with open("cut3d.files","a") as files:
                  files.write("ab2o_DS"+str(ii+1)+"_VHXC \n")
                  files.write("1 \n")
                  files.write("5 \n")
                  files.write("V-- \n")
                  files.write("0 \n")
  os.system("cut3d < cut3d.files ")
  
  os.system("rm cut3d.files")
  with open("cut3d.files","a") as files:
                  files.write("ab2o_DS"+str(ii+2)+"_VHXC \n")
                  files.write("1 \n")
                  files.write("5 \n")
                  files.write("V+- \n")
                  files.write("0 \n")
  os.system("cut3d < cut3d.files ")
  
  os.system("rm cut3d.files")
  with open("cut3d.files","a") as files:
                  files.write("ab2o_DS"+str(ii+3)+"_VHXC \n")
                  files.write("1 \n")
                  files.write("5 \n")
                  files.write("V-+ \n")
                  files.write("0 \n")
  os.system("cut3d < cut3d.files ")
  
  #Make centered finite difference of order 2 of Vhxc
  # d2Vhxc/dR1dR2=Vhxc(R1+h,R2+w)+Vhxc(R1-h,R2-w)-Vhxc(R1-h,R2+w)-Vhxc(R1+h,R2-w)/(4*hw)
  os.system("rm diff.files")
  with open("diff.files","a") as files:
                  files.write("V++\n")
                  files.write("V--\n")
                  files.write("V+-\n")
                  files.write("V-+\n")
                  files.write(str(h[(ii-2)/4]/np.sqrt(2))+"\n") # dist=0.01
  os.system("python Vhxc_diff_ordre2.py < diff.files ")
  
  #Perform the integration
  # band nb 2
  os.system("rm int.files")
  os.system("rm result")
  os.system("touch result")
  with open("int.files","a") as files:
                  files.write("D2V.dat\n") 
                  files.write("wfk_k1_b5_s1\n")
  os.system("python Int.py < int.files > result")
  
  # band nb 3
  os.system("rm int.files")
  with open("int.files","a") as files:
                  files.write("D2V.dat\n") 
                  files.write("wfk_k1_b6_s1\n")
  os.system("python Int.py < int.files >> result")
  
  # band nb 4
  os.system("rm int.files")
  with open("int.files","a") as files:
                  files.write("D2V.dat\n") 
                  files.write("wfk_k1_b7_s1\n")
  os.system("python Int.py < int.files >> result")
  
  #Make the average of the three band
  
  average = 0.0
  marker = False
  marker2 = False
  with open("result") as result:
  	for line in result:
  		if marker2:
  			average=average+float(line)
                        marker = False
  			marker2 = False
  		elif marker:
  			marker2 = True
  		elif line[0:25]=="Entrez le nom du deuxieme":
  			marker = True
  average = average/3
  Mcarbone = 21894.16693
#  omega_0=0.006064719  #Now gab value (previously 6.204201E-03)	
  omega_0=6.064741669E-03  #Now gab value (previously 6.204201E-03)	
  ZPM=3*(2*average)/(4*Mcarbone*omega_0) #in Ha, only for HOMO
  ZPMeV=ZPM*27.211383*1000 #in meV
  
  D[0,(ii-2)/4,0] = ZPMeV


  print "h: ",h[(ii-2)/4]
  print "ZPM[meV]"+str(ZPMeV)			
  with open("result_nddw.txt","a") as A:
    A.write("h: "+str(h[(ii-2)/4])+"\n")
    A.write("ZPR: "+str(ZPMeV)+"\n\n")


  ii += 4


l = 0
while l < len(h):
  k = 0
  while k < len(h):
    if (l-1) >= 0 and (k-1) >= 0:
#     LO mode   
      D[l,k,0] = (D[l-1,k,0]-(D[l-1,k-1,0]*(1.0/(2**(2*l)))))/\
                 (1-(1.0/(2**(2*l))))
      if D[l-1,k-1,0] == 0.0:
        D[l,k,0] = 0.0
    k += 1
  l += 1

print D





