import numpy as np

acell = np.array([1.0,1.0,1.0])*6.67527613817

rprim = np.array([[0.0,0.5,0.5],[0.5,0.0,0.5],[0.5,0.5,0.0]])

rprimd = np.matrix(rprim*acell)

kptrlatt = np.matrix([[1.0,0.0,0.0],[0.0,1.0,0.0],[0.0,0.0,1.0]])*6

sol = kptrlatt*rprimd

acell2 = np.array([2.0,1.0,1.0])*6.67527613817

rprim2 = np.array([[0.0,0.5,0.5],[0.5,0.0,0.5],[0.5,0.5,0.0]])

rprimd2 = np.matrix(rprim2*acell2)

print np.linalg.solve(rprimd2.transpose(),sol).transpose()


# To compute supercelll
a = rprimd*(np.matrix([1.0/8,1.0/8,5.0/8]).transpose()); print "%5.15f %5.15f %5.15f" %(a[0],a[1],a[2])

